define("smashThePigComponentsAnimationPort", ["componentmodelComponentApi", "clientkernelEventbusApi"],
    function(componentmodelComponentApi, clientkernelEventbusApi) {
        "use strict";

        function $iterator(o) {
            if (o instanceof Array) return function() {
                return {
                    cur: 0,
                    arr: o,
                    hasNext: function() {
                        return this.cur < this.arr.length;
                    },
                    next: function() {
                        return this.arr[this.cur++];
                    }
                };
            };
            return typeof(o.iterator) == 'function' ? $bind(o, o.iterator) : o.iterator;
        };;
        var $fid = 0;

        function $bind(o, m) {
            if (m == null) return null;
            if (m.__id__ == null) m.__id__ = $fid++;
            var f;
            if (o.hx__closures__ == null) o.hx__closures__ = {};
            else f = o.hx__closures__[m.__id__];
            if (f == null) {
                f = function() {
                    return f.method.apply(f.scope, arguments);
                };
                f.scope = o;
                f.method = m;
                o.hx__closures__[m.__id__] = f;
            }
            return f;
        };
        var $_;
        var $estr = function() {
            return _hcmn_.js_Boot.__string_rec(this, '');
        };
        if (typeof haxe == 'undefined') {
            var haxe = {};
        };

        haxe.IMap = function() {}
        haxe.IMap.prototype = {

        };
        if (typeof smashThePigComponentsAnimationPort == 'undefined') {
            var smashThePigComponentsAnimationPort = {};
        };

        smashThePigComponentsAnimationPort.IAnimationPort = function() {}
        smashThePigComponentsAnimationPort.IAnimationPort.prototype = {

            getShow: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            },
            getHide: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            }
        };

        smashThePigComponentsAnimationPort.IAnimationImplementationPort = function() {}
        smashThePigComponentsAnimationPort.IAnimationImplementationPort.prototype = {

            getShow: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            },
            getHide: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            }
        };
        smashThePigComponentsAnimationPort.AnimationPort = function(instance, bus) {
            this.show = instance.createTopic("animation:show");
            this.hide = instance.createTopic("animation:hide");
            this.show.connect(bus);
            this.hide.connect(bus);
        };
        smashThePigComponentsAnimationPort.AnimationPort = ck_implements(smashThePigComponentsAnimationPort.AnimationPort, smashThePigComponentsAnimationPort.IAnimationPort);
        smashThePigComponentsAnimationPort.AnimationPort = ck_implements(smashThePigComponentsAnimationPort.AnimationPort, smashThePigComponentsAnimationPort.IAnimationImplementationPort);
        smashThePigComponentsAnimationPort.AnimationPort.__interfaces__ = [smashThePigComponentsAnimationPort.IAnimationPort, smashThePigComponentsAnimationPort.IAnimationImplementationPort];
        smashThePigComponentsAnimationPort.AnimationPort.__name__ = ["smashThePigComponentsAnimationPort", "AnimationPort"];
        smashThePigComponentsAnimationPort.AnimationPort.prototype.show = null;
        smashThePigComponentsAnimationPort.AnimationPort.prototype.hide = null;
        smashThePigComponentsAnimationPort.AnimationPort.prototype.getShow = function() {
            return this.show;
        };
        smashThePigComponentsAnimationPort.AnimationPort.prototype.getHide = function() {
            return this.hide;
        };
        smashThePigComponentsAnimationPort.AnimationPort.prototype.__class__ = smashThePigComponentsAnimationPort.AnimationPort;
        smashThePigComponentsAnimationPort.AnimationPortFactory = function() {};
        smashThePigComponentsAnimationPort.AnimationPortFactory = ck_implements(smashThePigComponentsAnimationPort.AnimationPortFactory, componentmodelComponentApi.IComponentPortFactory);
        smashThePigComponentsAnimationPort.AnimationPortFactory.__interfaces__ = [componentmodelComponentApi.IComponentPortFactory];
        smashThePigComponentsAnimationPort.AnimationPortFactory.__name__ = ["smashThePigComponentsAnimationPort", "AnimationPortFactory"];
        smashThePigComponentsAnimationPort.AnimationPortFactory.prototype.provide = function(instance, channel) {
            return new smashThePigComponentsAnimationPort.AnimationPort(instance, channel);
        };
        smashThePigComponentsAnimationPort.AnimationPortFactory.prototype["use"] = function(instance, channel) {
            return new smashThePigComponentsAnimationPort.AnimationPort(instance, channel);
        };
        smashThePigComponentsAnimationPort.AnimationPortFactory.prototype.__class__ = smashThePigComponentsAnimationPort.AnimationPortFactory;
        smashThePigComponentsAnimationPort.ShowAnimationPayload = function(data) {
            this.data = data;
        };
        smashThePigComponentsAnimationPort.ShowAnimationPayload.__name__ = ["smashThePigComponentsAnimationPort", "ShowAnimationPayload"];
        smashThePigComponentsAnimationPort.ShowAnimationPayload.prototype.data = null;
        smashThePigComponentsAnimationPort.ShowAnimationPayload.prototype.__class__ = smashThePigComponentsAnimationPort.ShowAnimationPayload;
        return {
            exports: smashThePigComponentsAnimationPort
        };
    });
//# sourceURL=smashThePigAnimationPort.js